package com.i2edu.flutter_ali_camera

import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.PluginRegistry.Registrar

/** FlutterAliCameraPlugin */
public class FlutterAliCameraPlugin : FlutterPlugin {

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        flutterState = FlutterState(
                flutterPluginBinding.applicationContext,
                flutterPluginBinding.binaryMessenger,
                flutterPluginBinding.platformViewRegistry)
        flutterState?.startListening(CameraMethodHandler(flutterState!!))
    }

    companion object {
        private var flutterState: FlutterState? = null

        @JvmStatic
        fun registerWith(registrar: Registrar) {
            flutterState = FlutterState(
                    registrar.context(),
                    registrar.messenger(),
                    registrar.platformViewRegistry())
            flutterState?.startListening(CameraMethodHandler(flutterState!!))
        }
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        flutterState?.stopListening()
        flutterState = null
    }
}