package com.i2edu.flutter_ali_camera

import android.content.Context
import com.aliyun.sys.AlivcSdkCore
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.StandardMessageCodec
import io.flutter.plugin.platform.PlatformView
import io.flutter.plugin.platform.PlatformViewFactory
import io.flutter.plugin.platform.PlatformViewRegistry

class FlutterState(
        val context: Context,
        val binaryMessenger: BinaryMessenger,
        private val platformViewRegistry: PlatformViewRegistry) {
    
    private val methodChannel: MethodChannel = MethodChannel(binaryMessenger, "flutter_ali_camera")

    fun startListening(methodCallHandler: CameraMethodHandler) {
        // resister alivcsdkcore
        AlivcSdkCore.register(context)
        AlivcSdkCore.setLogLevel(AlivcSdkCore.AlivcLogLevel.AlivcLogDebug)

        platformViewRegistry.registerViewFactory("com.i2edu.cameraLib", object : PlatformViewFactory(StandardMessageCodec.INSTANCE) {
            override fun create(context: Context, viewId: Int, args: Any?): PlatformView {
                return AliCameraView(context, binaryMessenger, viewId, args)
            }
        })
        methodChannel.setMethodCallHandler(methodCallHandler)
    }

    fun stopListening() {
        methodChannel.setMethodCallHandler(null)
    }
}